/***************************************************************************
                          bomb.cpp  -  description
                             -------------------
    begin                : Sat Apr 27 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "bomb.h"
#include "sprite.h"
#include "timer.h"
#include "resources.h"
#include "explosion.h"
#include "map_sample.h"
#include "player.h"
#include "auriferous.h"

Bomb::Bomb(int _x, int _y, int _type, bool _op, Map_Sample* _sample) : Effects(_x, _y, _sample)
{
	type=_type;
	op=_op;
	timer=new Timer;
	timer->reset();
	
	if(type==1)
	sprite=new Sprite(Resources::Tiles(), 0.2f, 8, 12);
	else
	sprite=new Sprite(Resources::Tiles(), 0.2f, 20, 24);	
}
Bomb::~Bomb()
{
}
void Bomb::act()
{
	if(timer->time_elapsed()>=2.0f && type!=2)
	{
		this->set_delme();
		if(type==1)
		new Explosion(x-48, y-48, 1, sample);
		else
		new Explosion(x-48, y-48, 0, sample);		
	}
	else if(type==2)
	{
		if(op==0)
		{
			if(sample->p1->triggered())
			{
				new Explosion(x-48, y-48, 0, sample);
				this->set_delme();
        PLAY(Resources::Tnt());							
			}
		}
		else if(op==1)
		{
			if(sample->p2->triggered())
			{
				new Explosion(x-48, y-48, 0, sample);
				this->set_delme();
        PLAY(Resources::Tnt());
			}
		}
	}
}
void Bomb::show()
{
	sprite->put_screen(x, y);
}