/***************************************************************************
                          submenu.cpp  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "submenu.h"
#include "auriferous.h"
#include "button.h"
#include "game.h"
#include "arrow.h"
#include "wheel.h"
#include "checker.h"
#include "config.h"
#include "jukebox.h"
#include "timer.h"

Submenu::Submenu(Auriferous* _app)
{
	app=_app;
	activ=false;
	stype=CONFIG;
	level="";
	key=0;
	wait=false;
	timer=new Timer;
	old_vol=Config::get_music_vol();
	old_m=Config::get_music();
	key_buffer=new CL_InputBuffer(CL_Input::keyboards[0]);
}
Submenu::~Submenu()
{
}
void Submenu::new_sub(SubType st)
{
	stype=st;
	activ=true;
	app->menu->disable_ms(true);

	if(stype==CONFIG)
	{
		music=new Checker(100, 100, app->menu, Config::get_music());
		intro=new Checker(100, 164, app->menu, Config::get_intro());
		full_screen=new Checker(100, 132, app->menu, Config::get_full_screen());
		fps=new Checker(100, 196, app->menu, Config::get_fps());
		m_vol=new Wheel(400, 164, app->menu, 10, Config::get_music_vol());
		skill=new Wheel(600, 164, app->menu, 3, Config::get_skill());
		speed=new Wheel(800, 164, app->menu, 3, Config::get_speed());


		keys.push_back(new Button(250, 264, app->menu, "Left"));
		keys.push_back(new Button(250, 296, app->menu, "Right"));
		keys.push_back(new Button(250, 328, app->menu, "Up"));
		keys.push_back(new Button(250, 360, app->menu, "Down"));
		keys.push_back(new Button(250, 392, app->menu, "DigLeft"));
		keys.push_back(new Button(250, 424, app->menu, "DigRight"));
		keys.push_back(new Button(250, 456, app->menu, "Pickup"));
		keys.push_back(new Button(250, 488, app->menu, "Use"));
		keys.push_back(new Button(250, 520, app->menu, "Bomb"));

		keys.push_back(new Button(600, 264, app->menu, "Left"));
		keys.push_back(new Button(600, 296, app->menu, "Right"));
		keys.push_back(new Button(600, 328, app->menu, "Up"));
		keys.push_back(new Button(600, 360, app->menu, "Down"));
		keys.push_back(new Button(600, 392, app->menu, "DigLeft"));
		keys.push_back(new Button(600, 424, app->menu, "DigRight"));
		keys.push_back(new Button(600, 456, app->menu, "Pickup"));
		keys.push_back(new Button(600, 488, app->menu, "Use"));
		keys.push_back(new Button(600, 520, app->menu, "Bomb"));
	
		back=new Button(700, 640, app->menu, "Cancel");
		save=new Button(100, 590, app->menu, "Save");
		reset=new Button(400, 620, app->menu, "defaults!");


		wait=false;
		key=0;
		for(int i=0; i<18; i++)
		{
			i_keys[i]=Config::keys[i];
			s_keys[i]=key_name(i_keys[i]);
		}
		key_buffer->clear();
	}
	else
	{
    Config::read_maxl();
		start_game=new Button(100, 590, app->menu, "Start");
		back=new Button(700, 640, app->menu, "Back");
		skill=new Wheel(400, 350, app->menu, Config::get_maxl(), Config::get_last_level());
		a_up=new Arrow(400, 200, app->menu, UP);
		a_down=new Arrow(400, 232, app->menu, DOWN);
		level=Config::get_last_levelset();
 }
}
bool Submenu::active()
{
		return activ;
}
void Submenu::act()
{
	if(back->is_pressed()==true)
	{
		clean();
		activ=false;
		app->menu->disable_ms(false);
	}

	if(stype!=CONFIG)
	{
		if(start_game->is_pressed()==true)
		{
			Config::set_last_levelset(level);
			Config::set_last_level(skill->get_val());
			clean();
			activ=false;
			app->menu->disable_ms(false);
			start_new_game();
		}

		if(a_up->is_clicked()==true)
		{
			Config::next_map();
			Config::set_last_level(1);
			level=Config::get_last_levelset();
			Config::read_maxl();
			skill->set_max(Config::get_maxl());
			skill->set_val(1);			
		}
		else if(a_down->is_clicked()==true)
		{
			Config::prev_map();
			Config::set_last_level(1);
			level=Config::get_last_levelset();
			Config::read_maxl();
			skill->set_max(Config::get_maxl());
			skill->set_val(1);			
		}

		Resources::Rfontg()->print_left(432, 220, level);
		if(stype==ONEPLAYER)
		Resources::Cgfont()->print_center(512, 20, "Start a new Singeplayer game");
		else
		Resources::Cgfont()->print_center(512, 20, "Start a new Mulitiplayer game");
		Resources::Gfont()->print_left(400, 180, "Levelset:");
		Resources::Gfont()->print_left(400, 296, "Level:");
	}
	else
	{
		Resources::Cgfont()->print_center(512, 20, "Configure Auriferous:");
		Resources::Gfont()->print_left(132, 108, "Music");
		Resources::Gfont()->print_left(132, 139, "Fullscreen");
		Resources::Gfont()->print_left(132, 170, "Play the Intro");
		Resources::Gfont()->print_left(132, 201, "draw fps");
		Resources::Gfont()->print_left(400, 108, "Music Vol:");
		Resources::Gfont()->print_left(600, 108, "Severity:");
		Resources::Gfont()->print_left(800, 108, "gfx detail:");

		for(unsigned int i=0; i<keys.size(); i++)
		{
			if((keys[i]->is_pressed()==true && wait!=true) || s_keys[i]=="unknown")
			{
				key=i;
				wait=true;
				key_buffer->clear();
				timer->reset();
			}
		}

		wait_key();

		Resources::Gfont()->print_left(200, 232, "Keys for Player 2:");
		Resources::Gfont()->print_right(250, 264, s_keys[0]+":");
		Resources::Gfont()->print_right(250, 296, s_keys[1]+":");
		Resources::Gfont()->print_right(250, 328, s_keys[2]+":");
		Resources::Gfont()->print_right(250, 360, s_keys[3]+":");
		Resources::Gfont()->print_right(250, 392, s_keys[4]+":");
		Resources::Gfont()->print_right(250, 424, s_keys[5]+":");
		Resources::Gfont()->print_right(250, 456, s_keys[6]+":");
		Resources::Gfont()->print_right(250, 488, s_keys[7]+":");
		Resources::Gfont()->print_right(250, 520, s_keys[8]+":");
		Resources::Gfont()->print_left(550, 232, "Keys for Player 1:");
		Resources::Gfont()->print_right(600, 264, s_keys[9]+":");
		Resources::Gfont()->print_right(600, 296, s_keys[10]+":");
		Resources::Gfont()->print_right(600, 328, s_keys[11]+":");
		Resources::Gfont()->print_right(600, 360, s_keys[12]+":");
		Resources::Gfont()->print_right(600, 392, s_keys[13]+":");
		Resources::Gfont()->print_right(600, 424, s_keys[14]+":");
		Resources::Gfont()->print_right(600, 456, s_keys[15]+":");
		Resources::Gfont()->print_right(600, 488, s_keys[16]+":");
		Resources::Gfont()->print_right(600, 520, s_keys[17]+":");


    if(music->is_checked() && Config::get_music()==false)
    {
	    Jukebox::init((WorldType)(ran(5)));
    }

		Config::set_music(music->is_checked());
		Config::set_music_vol(m_vol->get_val());
		Config::set_fps(fps->is_checked());

		if(Config::get_music_vol()!=old_vol)
		{
			Jukebox::act();
			old_vol=Config::get_music_vol();
		}

		if(Config::get_music()!=old_m)
		{
 			Jukebox::act();
			old_m=Config::get_music();
		}

		if(reset->is_pressed()==true)
		{
			Config::reset();
			clean();
			activ=false;
			app->menu->disable_ms(false);
		}

		if(save->is_pressed()==true)
		{

			/*
			//if(waiting_for_CL_Display2()==false) :)
			//{
			if(Config::get_full_screen()!=full_screen->is_checked())
			{
			CL_Display2::set_videomode(just the new mode!);
			}
			//}
			*/

			Config::set_music(music->is_checked());
			Config::set_intro(intro->is_checked());
			Config::set_full_screen(full_screen->is_checked());
			Config::set_music_vol(m_vol->get_val());
			Config::set_skill(skill->get_val());
			Config::set_speed(speed->get_val());
			Config::set_fps(fps->is_checked());
			memcpy(Config::keys, i_keys, sizeof(int) * 18);
			clean();
			activ=false;
			app->menu->disable_ms(false);
		}
	}
}
void Submenu::start_new_game()
{
	app->menu->freeze_gui(true);
	Game* game=new Game(app);
	game->run(stype==TWOPLAYER);
	delete game;
	app->menu->freeze_gui(false);
	CL_MouseCursor::set_cursor(Resources::Cursor());
}
void Submenu::clean()
{
	if(stype==CONFIG)
	{
		music->set_Delete_Me();
		intro->set_Delete_Me();
		full_screen->set_Delete_Me();
		m_vol->set_Delete_Me();
		skill->set_Delete_Me();
		speed->set_Delete_Me();
		back->set_Delete_Me();
		save->set_Delete_Me();
		fps->set_Delete_Me();
		reset->set_Delete_Me();
		for(unsigned int i=0; i<keys.size(); i++)
			keys[i]->set_Delete_Me();
		keys.clear();
	}
	else
	{
		back->set_Delete_Me();
		start_game->set_Delete_Me();
		skill->set_Delete_Me();
		a_up->set_Delete_Me();
		a_down->set_Delete_Me();
	}
}
void Submenu::wait_key()
{	
	if(wait==true)
	{
		if(key_buffer->peek_key().state!=CL_Key::NoKey)
		{
			if(key_buffer->peek_key().id==CL_KEY_ESCAPE)
			s_keys[key]=key_name(i_keys[key]);
			else
			i_keys[key]=key_buffer->peek_key().id;

			s_keys[key]=key_name(i_keys[key]);
			wait=false;
		}
		else
		{
			s_keys[key]="";

			if(timer->time_elapsed()>0.1f)
			{
				s_keys[key]+="P";
			}
			if(timer->time_elapsed()>0.2f)
			{
				s_keys[key]+="r";
			}
			if(timer->time_elapsed()>0.3f)
			{
				s_keys[key]+="e";
			}
			if(timer->time_elapsed()>0.4f)
			{
				s_keys[key]+="s";
			}
			if(timer->time_elapsed()>0.5f)
			{
				s_keys[key]+="s";
			}
			if(timer->time_elapsed()>0.6f)
			{
				s_keys[key]+=" a";
			}
			if(timer->time_elapsed()>0.7f)
			{
				s_keys[key]+=" K";
			}
			if(timer->time_elapsed()>0.8f)
			{
				s_keys[key]+="e";
			}
			if(timer->time_elapsed()>0.9f)
			{
				s_keys[key]+="y";
			}
			if(timer->time_elapsed()>1.0f)
			{
					s_keys[key]+="!";

					if(timer->time_elapsed()>1.4f)
					timer->reset();
			}
		}
	}
}

CL_String Submenu::key_name(int k)
{
	CL_String str("");

	switch(k)
	{
	case CL_KEY_A: str = "A"; break;
	case CL_KEY_B: str = "B"; break;
	case CL_KEY_C: str = "C"; break;
	case CL_KEY_D: str = "D"; break;
	case CL_KEY_E: str = "E"; break;
	case CL_KEY_F: str = "F"; break;
	case CL_KEY_G: str = "G"; break;
	case CL_KEY_H: str = "H"; break;
	case CL_KEY_I: str = "I"; break;
	case CL_KEY_J: str = "J"; break;
	case CL_KEY_K: str = "K"; break;
	case CL_KEY_L: str = "L"; break;
	case CL_KEY_M: str = "M"; break;
	case CL_KEY_N: str = "N"; break;
	case CL_KEY_O: str = "O"; break;
	case CL_KEY_P: str = "P"; break;
	case CL_KEY_Q: str = "Q"; break;
	case CL_KEY_R: str = "R"; break;
	case CL_KEY_S: str = "S"; break;
	case CL_KEY_T: str = "T"; break;
	case CL_KEY_U: str = "U"; break;
	case CL_KEY_V: str = "V"; break;
	case CL_KEY_W: str = "W"; break;
	case CL_KEY_X: str = "X"; break;
	case CL_KEY_Y: str = "Y"; break;
	case CL_KEY_Z: str = "Z"; break;
	case CL_KEY_0: str = "0"; break;
	case CL_KEY_1: str = "1"; break;
	case CL_KEY_2: str = "2"; break;
	case CL_KEY_3: str = "3"; break;
	case CL_KEY_4: str = "4"; break;
	case CL_KEY_5: str = "5"; break;
	case CL_KEY_6: str = "6"; break;
	case CL_KEY_7: str = "7"; break;
	case CL_KEY_8: str = "8"; break;
	case CL_KEY_9: str = "9"; break;
	case CL_KEY_F1:  str = "F1"; break;
	case CL_KEY_F2:  str = "F2"; break;
	case CL_KEY_F3:  str = "F3"; break;
	case CL_KEY_F4:  str = "F4"; break;
	case CL_KEY_F5:  str = "F5"; break;
	case CL_KEY_F6:  str = "F6"; break;
	case CL_KEY_F7:  str = "F7"; break;
	case CL_KEY_F8:  str = "F8"; break;
	case CL_KEY_F9:  str = "F9"; break;
	case CL_KEY_F10:  str = "F10"; break;
	case CL_KEY_F11:  str = "F11"; break;
	case CL_KEY_F12:  str = "F12"; break;
	case CL_KEY_ESCAPE: str = "Escape"; break;
	case CL_KEY_LEFT: str = "Left"; break;
	case CL_KEY_UP: str = "Up"; break;
	case CL_KEY_DOWN: str = "Down"; break;
	case CL_KEY_RIGHT: str = "Right"; break;
	case CL_KEY_LCTRL: str = "L_Ctrl"; break;
	case CL_KEY_RCTRL: str = "R_Ctrl"; break;
	case CL_KEY_LSHIFT: str = "L_Shift"; break;
	case CL_KEY_RSHIFT: str = "R_Shift"; break;
	case CL_KEY_ALT: str = "Alt"; break;
	case CL_KEY_ALTGR: str = "Alt Gr"; break;
	case CL_KEY_TAB: str = "Tab"; break;
	case CL_KEY_ENTER: str = "Enter"; break;
	case CL_KEY_SPACE: str = "Space"; break;
	case CL_KEY_BACKSPACE: str = "Backspace"; break;
	case CL_KEY_INSERT: str = "Insert"; break;
	case CL_KEY_DELETE: str = "Delete"; break;
	case CL_KEY_HOME: str = "Home"; break;
	case CL_KEY_END: str = "End"; break;
	case CL_KEY_PAGEUP: str = "Page Up"; break;
	case CL_KEY_PAGEDOWN: str = "Page Down"; break;
	case CL_KEY_CAPSLOCK: str = "Caps Lock"; break;
	case CL_KEY_NUMLOCK: str = "Num Lock"; break;
	case CL_KEY_SCRLOCK: str = "Scroll Lock"; break;
	case CL_KEY_PRINT: str = "Print Screen"; break;
	case CL_KEY_PAUSE: str = "Pause"; break;
	case CL_KEY_KP_DECIMAL: str = "KP Period"; break;
	case CL_KEY_KP_0: str = "KP 0"; break;
	case CL_KEY_KP_1: str = "KP 1"; break;
	case CL_KEY_KP_2: str = "KP 2"; break;
	case CL_KEY_KP_3: str = "KP 3"; break;
	case CL_KEY_KP_4: str = "KP 4"; break;
	case CL_KEY_KP_5: str = "KP 5"; break;
	case CL_KEY_KP_6: str = "KP 6"; break;
	case CL_KEY_KP_7: str = "KP 7"; break;
	case CL_KEY_KP_8: str = "KP 8"; break;
	case CL_KEY_KP_9: str = "KP 9"; break;
	case CL_KEY_KP_DIV: str = "KP Div"; break;
	case CL_KEY_KP_MULT: str = "KP Mult"; break;
	case CL_KEY_KP_MINUS: str = "KP Minus"; break;
	case CL_KEY_KP_PLUS: str = "KP Plus"; break;
	case CL_KEY_KP_ENTER: str = "KP Enter"; break;
	case CL_KEY_GRAVE: str = "Grave"; break;
	case CL_KEY_SUBTRACT: str = "Minus"; break;
	case CL_KEY_EQUALS: str = "Equals"; break;
	case CL_KEY_LEFT_BRACKET: str = "Left Bracket"; break;
	case CL_KEY_RIGHT_BRACKET: str = "Right Bracket"; break;
	case CL_KEY_SEMICOLON: str = "Semicolon"; break;
	case CL_KEY_QUOTE: str = "Quote"; break;
	case CL_KEY_COMMA: str = "Comma"; break;
	case CL_KEY_PERIOD: str = "Period"; break;
	case CL_KEY_DIVIDE: str = "Divide"; break;
	case CL_KEY_BACKSLASH: str = "Backslash"; break;
	case CL_KEY_LWIN: str = "Left Win"; break;
	case CL_KEY_RWIN: str = "Right Win"; break;
	case CL_KEY_APPS: str = "Menu"; break;
	case CL_KEY_COMPOSE: str = "Compose"; break;
	case CL_NUM_KEYS: str = "CL_NUM_KEYS"; break;
	case CL_KEY_NONE_OF_THE_ABOVE: str = "unknown"; break;
	}

	return str;
}

